//
// $Id: Receiver_Factory.cpp 76591 2007-01-25 18:17:52Z elliott_c $
//
#include "Receiver_Factory.h"
#include "Receiver.h"

ACE_RCSID(Throughput, Receiver_Factory, "$Id: Receiver_Factory.cpp 76591 2007-01-25 18:17:52Z elliott_c $")

Receiver_Factory::Receiver_Factory (CORBA::ORB_ptr orb)
  : orb_ (CORBA::ORB::_duplicate (orb))
{
}

Test::Receiver_ptr
Receiver_Factory::create_receiver (void)
  ACE_THROW_SPEC ((CORBA::SystemException))
{
  Receiver *receiver_impl = 0;
  ACE_NEW_THROW_EX (receiver_impl,
                    Receiver,
                    CORBA::NO_MEMORY ());
  PortableServer::ServantBase_var transfer_ownership(receiver_impl);

  return receiver_impl->_this ();
}

void
Receiver_Factory::shutdown (void)
  ACE_THROW_SPEC ((CORBA::SystemException))
{
  this->orb_->shutdown (0);
}
